#include	<Windows.h>
#include	<gdiplus.h>
#include	<iostream>

#pragma comment(lib, "Gdiplus.lib")

const auto filename = LR"(..\bbb.bmp)";

int main(void)
{
	auto file = CreateFileW(filename, GENERIC_READ, FILE_SHARE_READ, nullptr, OPEN_EXISTING, 0, nullptr);
	DWORD dwRead;
	BITMAPFILEHEADER bfh;
	ReadFile(file, &bfh, sizeof(bfh), &dwRead, nullptr);
	BITMAPINFOHEADER bfi;
	ReadFile(file, &bfi, sizeof(bfi), &dwRead, nullptr);
	CloseHandle(file);

	std::cout << "biXPelsPerMeter : " << bfi.biXPelsPerMeter << "dpm (" << 0.0254 * bfi.biXPelsPerMeter << "dpi)" << std::endl;
	std::cout << "biYPelsPerMeter : " << bfi.biYPelsPerMeter << "dpm (" << 0.0254 * bfi.biYPelsPerMeter << "dpi)" << std::endl;

	Gdiplus::GdiplusStartupInput gdiplusStartupInput;
	ULONG_PTR gdiplusToken;

	Gdiplus::GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, nullptr);

	auto bmp = Gdiplus::Bitmap::FromFile(filename);

	std::cout << "Bitmap.HorizontalResolution : " << bmp->GetHorizontalResolution() << "dpi (" << bmp->GetHorizontalResolution() / 0.0254 << "dpm)" << std::endl;
	std::cout << "Bitmap.VerticalResolution   : " << bmp->GetVerticalResolution() << "dpi (" << bmp->GetVerticalResolution() / 0.0254 << "dpm)" << std::endl;

	delete bmp;

	return 0;
}